require_relative '../helper'

class TestInstance < TestCase

  def test_get_all_instances
    instances = Instance.all
    assert_kind_of(Array, instances)
  end

  def test_infer_type_from_name
    i = Instance.new name: "web-thing"
    assert_equal :web, i.type
  end

  def test_aster_environment
    instance = Instance.new type: :web
    e = instance.aster_environment
    assert_equal("2", e.eval("add 1 1"))
    e.eval "upload nginx/nginx.conf ~/nginx.test"
    assert_equal ["~/nginx.test"], instance.mock_file_system.keys
  end

  def test_default_config
    hex = SecureRandom.hex
    i = Instance.new type: :web, id: hex
    assert_equal "22", i["ssh.port"]
    i["ssh.port"] = "1234"

    i = Instance.new type: :web, id: hex
    assert_equal "1234", i["ssh.port"]
  end

  def test_instance_namespace
    i = Instance.new name: "name:web-23423423"
    assert_equal :web, i.server.type
    assert_equal "name", i.namespace
  end


end